<?php

namespace optsoapsdk\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for UpdateAgentLevelUpline StructType
 * @subpackage Structs
 */
class UpdateAgentLevelUpline extends AbstractStructBase
{
    /**
     * The AgentID
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AgentID;
    /**
     * The AgentLevel
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $AgentLevel;
    /**
     * The Upline
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * - nillable: true
     * @var string
     */
    public $Upline;
    /**
     * Constructor method for UpdateAgentLevelUpline
     * @uses UpdateAgentLevelUpline::setAgentID()
     * @uses UpdateAgentLevelUpline::setAgentLevel()
     * @uses UpdateAgentLevelUpline::setUpline()
     * @param string $agentID
     * @param string $agentLevel
     * @param string $upline
     */
    public function __construct($agentID = null, $agentLevel = null, $upline = null)
    {
        $this
            ->setAgentID($agentID)
            ->setAgentLevel($agentLevel)
            ->setUpline($upline);
    }
    /**
     * Get AgentID value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgentID()
    {
        return isset($this->AgentID) ? $this->AgentID : null;
    }
    /**
     * Set AgentID value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agentID
     * @return \optsoapsdk\StructType\UpdateAgentLevelUpline
     */
    public function setAgentID($agentID = null)
    {
        // validation for constraint: string
        if (!is_null($agentID) && !is_string($agentID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agentID, true), gettype($agentID)), __LINE__);
        }
        if (is_null($agentID) || (is_array($agentID) && empty($agentID))) {
            unset($this->AgentID);
        } else {
            $this->AgentID = $agentID;
        }
        return $this;
    }
    /**
     * Get AgentLevel value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getAgentLevel()
    {
        return isset($this->AgentLevel) ? $this->AgentLevel : null;
    }
    /**
     * Set AgentLevel value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $agentLevel
     * @return \optsoapsdk\StructType\UpdateAgentLevelUpline
     */
    public function setAgentLevel($agentLevel = null)
    {
        // validation for constraint: string
        if (!is_null($agentLevel) && !is_string($agentLevel)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($agentLevel, true), gettype($agentLevel)), __LINE__);
        }
        if (is_null($agentLevel) || (is_array($agentLevel) && empty($agentLevel))) {
            unset($this->AgentLevel);
        } else {
            $this->AgentLevel = $agentLevel;
        }
        return $this;
    }
    /**
     * Get Upline value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return string|null
     */
    public function getUpline()
    {
        return isset($this->Upline) ? $this->Upline : null;
    }
    /**
     * Set Upline value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @param string $upline
     * @return \optsoapsdk\StructType\UpdateAgentLevelUpline
     */
    public function setUpline($upline = null)
    {
        // validation for constraint: string
        if (!is_null($upline) && !is_string($upline)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($upline, true), gettype($upline)), __LINE__);
        }
        if (is_null($upline) || (is_array($upline) && empty($upline))) {
            unset($this->Upline);
        } else {
            $this->Upline = $upline;
        }
        return $this;
    }
}
